/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceAccessibleJoint_h__
#define __surface_SurfaceAccessibleJoint_h__

namespace fe
{

/**************************************************************************//**
    @brief Joint Surface Binding

	@ingroup surface
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleJoint:
	public SurfaceAccessibleBase
{
	public:
								SurfaceAccessibleJoint(void):
									m_frame(0.0)							{}
virtual							~SurfaceAccessibleJoint(void)				{}

								//* as SurfaceAccessibleI

virtual	BWORD					load(String a_filename)
								{	return load(a_filename,0.0,
											sp<StringFilterI>(NULL)); }
virtual	BWORD					load(String a_filename,Real a_frame,
										sp<StringFilterI> a_spFilter)
								{	return FALSE; }

		void					startJoints(void);
		BWORD					addJointTweaked(
									String a_name,String a_parentName,
									const SpatialTransform& a_rXformRelative,
									const SpatialTransform& a_rRefWorld,
									Color a_color);
		BWORD					addJoint(String a_name,String a_parentName,
									const SpatialTransform& a_rAnimLocal,
									const SpatialTransform& a_rAnimWorld,
									const SpatialTransform& a_rRefWorld,
									Color a_color);
		BWORD					addJoint(String a_name,String a_parentName,
									const SpatialTransform& a_rAnimLocal,
									const SpatialTransform& a_rAnimWorld,
									Color a_color);

	protected:

		Real								m_frame;
		sp<StringFilterI>					m_spFilter;

		sp<SurfaceAccessorI>				m_spOutputPoint;
		sp<SurfaceAccessorI>				m_spOutputColor;
		sp<SurfaceAccessorI>				m_spOutputNormal;
		sp<SurfaceAccessorI>				m_spOutputName;
		sp<SurfaceAccessorI>				m_spOutputParent;
		sp<SurfaceAccessorI>				m_spOutputRefX;
		sp<SurfaceAccessorI>				m_spOutputRefY;
		sp<SurfaceAccessorI>				m_spOutputRefZ;
		sp<SurfaceAccessorI>				m_spOutputRefT;
		sp<SurfaceAccessorI>				m_spOutputAnimX;
		sp<SurfaceAccessorI>				m_spOutputAnimY;
		sp<SurfaceAccessorI>				m_spOutputAnimZ;
		sp<SurfaceAccessorI>				m_spOutputAnimT;
		sp<SurfaceAccessorI>				m_spOutputVertices;

		std::map<String,SpatialTransform>	m_hiddenTransform;
		std::map<String,String>				m_delegateName;
		std::map<String,SpatialTransform>	m_animMap;
		std::map<String,SpatialTransform>	m_refTweakMap;
		std::map<String,SpatialTransform>	m_animTweakMap;
		std::map<String,SpatialTransform>	m_deltaMap;
};

} // namespace

#endif /* __surface_SurfaceAccessibleJoint_h__ */
